<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/memchr-2.5.0/src/memmem/prefilter/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../memchr/index.html"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::memmem</span>::{<span class="ident">rarebytes::RareNeedleBytes</span>, <span class="ident">NeedleInfo</span>};

<span class="kw">mod</span> <span class="ident">fallback</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">memchr_runtime_simd</span>)]</span>
<span class="kw">mod</span> <span class="ident">genericsimd</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">memchr_runtime_simd</span>))]</span>
<span class="kw">mod</span> <span class="ident">wasm</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>, <span class="ident">memchr_runtime_simd</span>))]</span>
<span class="kw">mod</span> <span class="ident">x86</span>;

<span class="doccomment">/// The maximum frequency rank permitted for the fallback prefilter. If the</span>
<span class="doccomment">/// rarest byte in the needle has a frequency rank above this value, then no</span>
<span class="doccomment">/// prefilter is used if the fallback prefilter would otherwise be selected.</span>
<span class="kw">const</span> <span class="ident">MAX_FALLBACK_RANK</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">250</span>;

<span class="doccomment">/// A combination of prefilter effectiveness state, the prefilter function and</span>
<span class="doccomment">/// the needle info required to run a prefilter.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// For the most part, these are grouped into a single type for convenience,</span>
<span class="doccomment">/// instead of needing to pass around all three as distinct function</span>
<span class="doccomment">/// parameters.</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">Pre</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// State that tracks the effectiveness of a prefilter.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">state</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">PrefilterState</span>,
    <span class="doccomment">/// The actual prefilter function.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">prefn</span>: <span class="ident">PrefilterFn</span>,
    <span class="doccomment">/// Information about a needle, such as its RK hash and rare byte offsets.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">ninfo</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="ident">NeedleInfo</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">Pre</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Call this prefilter on the given haystack with the given needle.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">call</span>(
        <span class="kw-2">&amp;mut</span> <span class="self">self</span>,
        <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    ) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">prefn</span>.<span class="ident">call</span>(<span class="self">self</span>.<span class="ident">state</span>, <span class="self">self</span>.<span class="ident">ninfo</span>, <span class="ident">haystack</span>, <span class="ident">needle</span>)
    }

    <span class="doccomment">/// Return true if and only if this prefilter should be used.</span>
    <span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">should_call</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">state</span>.<span class="ident">is_effective</span>()
    }
}

<span class="doccomment">/// A prefilter function.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A prefilter function describes both forward and reverse searches.</span>
<span class="doccomment">/// (Although, we don&#39;t currently implement prefilters for reverse searching.)</span>
<span class="doccomment">/// In the case of a forward search, the position returned corresponds to</span>
<span class="doccomment">/// the starting offset of a match (confirmed or possible). Its minimum</span>
<span class="doccomment">/// value is `0`, and its maximum value is `haystack.len() - 1`. In the case</span>
<span class="doccomment">/// of a reverse search, the position returned corresponds to the position</span>
<span class="doccomment">/// immediately after a match (confirmed or possible). Its minimum value is `1`</span>
<span class="doccomment">/// and its maximum value is `haystack.len()`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// In both cases, the position returned is the starting (or ending) point of a</span>
<span class="doccomment">/// _possible_ match. That is, returning a false positive is okay. A prefilter,</span>
<span class="doccomment">/// however, must never return any false negatives. That is, if a match exists</span>
<span class="doccomment">/// at a particular position `i`, then a prefilter _must_ return that position.</span>
<span class="doccomment">/// It cannot skip past it.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Safety</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A prefilter function is not safe to create, since not all prefilters are</span>
<span class="doccomment">/// safe to call in all contexts. (e.g., A prefilter that uses AVX instructions</span>
<span class="doccomment">/// may only be called on x86_64 CPUs with the relevant AVX feature enabled.)</span>
<span class="doccomment">/// Thus, callers must ensure that when a prefilter function is created that it</span>
<span class="doccomment">/// is safe to call for the current environment.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">PrefilterFn</span>(<span class="ident">PrefilterFnTy</span>);

<span class="doccomment">/// The type of a prefilter function. All prefilters must satisfy this</span>
<span class="doccomment">/// signature.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Using a function pointer like this does inhibit inlining, but it does</span>
<span class="doccomment">/// eliminate branching and the extra costs associated with copying a larger</span>
<span class="doccomment">/// enum. Note also, that using Box&lt;dyn SomePrefilterTrait&gt; can&#39;t really work</span>
<span class="doccomment">/// here, since we want to work in contexts that don&#39;t have dynamic memory</span>
<span class="doccomment">/// allocation. Moreover, in the default configuration of this crate on x86_64</span>
<span class="doccomment">/// CPUs released in the past ~decade, we will use an AVX2-optimized prefilter,</span>
<span class="doccomment">/// which generally won&#39;t be inlineable into the surrounding code anyway.</span>
<span class="doccomment">/// (Unless AVX2 is enabled at compile time, but this is typically rare, since</span>
<span class="doccomment">/// it produces a non-portable binary.)</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">type</span> <span class="ident">PrefilterFnTy</span> <span class="op">=</span> <span class="kw">unsafe</span> <span class="kw">fn</span>(
    <span class="ident">prestate</span>: <span class="kw-2">&amp;mut</span> <span class="ident">PrefilterState</span>,
    <span class="ident">ninfo</span>: <span class="kw-2">&amp;</span><span class="ident">NeedleInfo</span>,
    <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>;

<span class="comment">// If the haystack is too small for SSE2, then just run memchr on the</span>
<span class="comment">// rarest byte and be done with it. (It is likely that this code path is</span>
<span class="comment">// rarely exercised, since a higher level routine will probably dispatch to</span>
<span class="comment">// Rabin-Karp for such a small haystack.)</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">memchr_runtime_simd</span>)]</span>
<span class="kw">fn</span> <span class="ident">simple_memchr_fallback</span>(
    <span class="ident">_prestate</span>: <span class="kw-2">&amp;mut</span> <span class="ident">PrefilterState</span>,
    <span class="ident">ninfo</span>: <span class="kw-2">&amp;</span><span class="ident">NeedleInfo</span>,
    <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="kw">let</span> (<span class="ident">rare</span>, <span class="kw">_</span>) <span class="op">=</span> <span class="ident">ninfo</span>.<span class="ident">rarebytes</span>.<span class="ident">as_rare_ordered_usize</span>();
    <span class="ident"><span class="kw">crate</span>::memchr</span>(<span class="ident">needle</span>[<span class="ident">rare</span>], <span class="ident">haystack</span>).<span class="ident">map</span>(<span class="op">|</span><span class="ident">i</span><span class="op">|</span> <span class="ident">i</span>.<span class="ident">saturating_sub</span>(<span class="ident">rare</span>))
}

<span class="kw">impl</span> <span class="ident">PrefilterFn</span> {
    <span class="doccomment">/// Create a new prefilter function from the function pointer given.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Safety</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Callers must ensure that the given prefilter function is safe to call</span>
    <span class="doccomment">/// for all inputs in the current environment. For example, if the given</span>
    <span class="doccomment">/// prefilter function uses AVX instructions, then the caller must ensure</span>
    <span class="doccomment">/// that the appropriate AVX CPU features are enabled.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">prefn</span>: <span class="ident">PrefilterFnTy</span>) -&gt; <span class="ident">PrefilterFn</span> {
        <span class="ident">PrefilterFn</span>(<span class="ident">prefn</span>)
    }

    <span class="doccomment">/// Call the underlying prefilter function with the given arguments.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">call</span>(
        <span class="self">self</span>,
        <span class="ident">prestate</span>: <span class="kw-2">&amp;mut</span> <span class="ident">PrefilterState</span>,
        <span class="ident">ninfo</span>: <span class="kw-2">&amp;</span><span class="ident">NeedleInfo</span>,
        <span class="ident">haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
        <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
    ) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="comment">// SAFETY: Callers have the burden of ensuring that a prefilter</span>
        <span class="comment">// function is safe to call for all inputs in the current environment.</span>
        <span class="kw">unsafe</span> { (<span class="self">self</span>.<span class="number">0</span>)(<span class="ident">prestate</span>, <span class="ident">ninfo</span>, <span class="ident">haystack</span>, <span class="ident">needle</span>) }
    }
}

<span class="kw">impl</span> <span class="ident">core::fmt::Debug</span> <span class="kw">for</span> <span class="ident">PrefilterFn</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">core::fmt::Formatter</span>) -&gt; <span class="ident">core::fmt::Result</span> {
        <span class="string">&quot;&lt;prefilter-fn(...)&gt;&quot;</span>.<span class="ident">fmt</span>(<span class="ident">f</span>)
    }
}

<span class="doccomment">/// Prefilter controls whether heuristics are used to accelerate searching.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A prefilter refers to the idea of detecting candidate matches very quickly,</span>
<span class="doccomment">/// and then confirming whether those candidates are full matches. This</span>
<span class="doccomment">/// idea can be quite effective since it&#39;s often the case that looking for</span>
<span class="doccomment">/// candidates can be a lot faster than running a complete substring search</span>
<span class="doccomment">/// over the entire input. Namely, looking for candidates can be done with</span>
<span class="doccomment">/// extremely fast vectorized code.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The downside of a prefilter is that it assumes false positives (which are</span>
<span class="doccomment">/// candidates generated by a prefilter that aren&#39;t matches) are somewhat rare</span>
<span class="doccomment">/// relative to the frequency of full matches. That is, if a lot of false</span>
<span class="doccomment">/// positives are generated, then it&#39;s possible for search time to be worse</span>
<span class="doccomment">/// than if the prefilter wasn&#39;t enabled in the first place.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Another downside of a prefilter is that it can result in highly variable</span>
<span class="doccomment">/// performance, where some cases are extraordinarily fast and others aren&#39;t.</span>
<span class="doccomment">/// Typically, variable performance isn&#39;t a problem, but it may be for your use</span>
<span class="doccomment">/// case.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The use of prefilters in this implementation does use a heuristic to detect</span>
<span class="doccomment">/// when a prefilter might not be carrying its weight, and will dynamically</span>
<span class="doccomment">/// disable its use. Nevertheless, this configuration option gives callers</span>
<span class="doccomment">/// the ability to disable prefilters if you have knowledge that they won&#39;t be</span>
<span class="doccomment">/// useful.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Prefilter</span> {
    <span class="doccomment">/// Never used a prefilter in substring search.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// Automatically detect whether a heuristic prefilter should be used. If</span>
    <span class="doccomment">/// it is used, then heuristics will be used to dynamically disable the</span>
    <span class="doccomment">/// prefilter if it is believed to not be carrying its weight.</span>
    <span class="ident">Auto</span>,
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Prefilter</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="ident">Prefilter</span> {
        <span class="ident">Prefilter::Auto</span>
    }
}

<span class="kw">impl</span> <span class="ident">Prefilter</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">is_none</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Prefilter::None</span> =&gt; <span class="bool-val">true</span>,
            <span class="kw">_</span> =&gt; <span class="bool-val">false</span>,
        }
    }
}

<span class="doccomment">/// PrefilterState tracks state associated with the effectiveness of a</span>
<span class="doccomment">/// prefilter. It is used to track how many bytes, on average, are skipped by</span>
<span class="doccomment">/// the prefilter. If this average dips below a certain threshold over time,</span>
<span class="doccomment">/// then the state renders the prefilter inert and stops using it.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A prefilter state should be created for each search. (Where creating an</span>
<span class="doccomment">/// iterator is treated as a single search.) A prefilter state should only be</span>
<span class="doccomment">/// created from a `Freqy`. e.g., An inert `Freqy` will produce an inert</span>
<span class="doccomment">/// `PrefilterState`.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">PrefilterState</span> {
    <span class="doccomment">/// The number of skips that has been executed. This is always 1 greater</span>
    <span class="doccomment">/// than the actual number of skips. The special sentinel value of 0</span>
    <span class="doccomment">/// indicates that the prefilter is inert. This is useful to avoid</span>
    <span class="doccomment">/// additional checks to determine whether the prefilter is still</span>
    <span class="doccomment">/// &quot;effective.&quot; Once a prefilter becomes inert, it should no longer be</span>
    <span class="doccomment">/// used (according to our heuristics).</span>
    <span class="ident">skips</span>: <span class="ident">u32</span>,
    <span class="doccomment">/// The total number of bytes that have been skipped.</span>
    <span class="ident">skipped</span>: <span class="ident">u32</span>,
}

<span class="kw">impl</span> <span class="ident">PrefilterState</span> {
    <span class="doccomment">/// The minimum number of skip attempts to try before considering whether</span>
    <span class="doccomment">/// a prefilter is effective or not.</span>
    <span class="kw">const</span> <span class="ident">MIN_SKIPS</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">50</span>;

    <span class="doccomment">/// The minimum amount of bytes that skipping must average.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This value was chosen based on varying it and checking</span>
    <span class="doccomment">/// the microbenchmarks. In particular, this can impact the</span>
    <span class="doccomment">/// pathological/repeated-{huge,small} benchmarks quite a bit if it&#39;s set</span>
    <span class="doccomment">/// too low.</span>
    <span class="kw">const</span> <span class="ident">MIN_SKIP_BYTES</span>: <span class="ident">u32</span> <span class="op">=</span> <span class="number">8</span>;

    <span class="doccomment">/// Create a fresh prefilter state.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="ident">PrefilterState</span> {
        <span class="ident">PrefilterState</span> { <span class="ident">skips</span>: <span class="number">1</span>, <span class="ident">skipped</span>: <span class="number">0</span> }
    }

    <span class="doccomment">/// Create a fresh prefilter state that is always inert.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">inert</span>() -&gt; <span class="ident">PrefilterState</span> {
        <span class="ident">PrefilterState</span> { <span class="ident">skips</span>: <span class="number">0</span>, <span class="ident">skipped</span>: <span class="number">0</span> }
    }

    <span class="doccomment">/// Update this state with the number of bytes skipped on the last</span>
    <span class="doccomment">/// invocation of the prefilter.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">update</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">skipped</span>: <span class="ident">usize</span>) {
        <span class="self">self</span>.<span class="ident">skips</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">skips</span>.<span class="ident">saturating_add</span>(<span class="number">1</span>);
        <span class="comment">// We need to do this dance since it&#39;s technically possible for</span>
        <span class="comment">// `skipped` to overflow a `u32`. (And we use a `u32` to reduce the</span>
        <span class="comment">// size of a prefilter state.)</span>
        <span class="kw">if</span> <span class="ident">skipped</span> <span class="op">&gt;</span> <span class="ident">core::u32::MAX</span> <span class="kw">as</span> <span class="ident">usize</span> {
            <span class="self">self</span>.<span class="ident">skipped</span> <span class="op">=</span> <span class="ident">core::u32::MAX</span>;
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">skipped</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">skipped</span>.<span class="ident">saturating_add</span>(<span class="ident">skipped</span> <span class="kw">as</span> <span class="ident">u32</span>);
        }
    }

    <span class="doccomment">/// Return true if and only if this state indicates that a prefilter is</span>
    <span class="doccomment">/// still effective.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">is_effective</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">is_inert</span>() {
            <span class="kw">return</span> <span class="bool-val">false</span>;
        }
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">skips</span>() <span class="op">&lt;</span> <span class="ident">PrefilterState::MIN_SKIPS</span> {
            <span class="kw">return</span> <span class="bool-val">true</span>;
        }
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">skipped</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">PrefilterState::MIN_SKIP_BYTES</span> <span class="op">*</span> <span class="self">self</span>.<span class="ident">skips</span>() {
            <span class="kw">return</span> <span class="bool-val">true</span>;
        }

        <span class="comment">// We&#39;re inert.</span>
        <span class="self">self</span>.<span class="ident">skips</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="bool-val">false</span>
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">is_inert</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">skips</span> <span class="op">==</span> <span class="number">0</span>
    }

    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">skips</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u32</span> {
        <span class="self">self</span>.<span class="ident">skips</span>.<span class="ident">saturating_sub</span>(<span class="number">1</span>)
    }
}

<span class="doccomment">/// Determine which prefilter function, if any, to use.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This only applies to x86_64 when runtime SIMD detection is enabled (which</span>
<span class="doccomment">/// is the default). In general, we try to use an AVX prefilter, followed by</span>
<span class="doccomment">/// SSE and then followed by a generic one based on memchr.</span>
<span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">forward</span>(
    <span class="ident">config</span>: <span class="kw-2">&amp;</span><span class="ident">Prefilter</span>,
    <span class="ident">rare</span>: <span class="kw-2">&amp;</span><span class="ident">RareNeedleBytes</span>,
    <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>],
) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">PrefilterFn</span><span class="op">&gt;</span> {
    <span class="kw">if</span> <span class="ident">config</span>.<span class="ident">is_none</span>() <span class="op">|</span><span class="op">|</span> <span class="ident">needle</span>.<span class="ident">len</span>() <span class="op">&lt;</span><span class="op">=</span> <span class="number">1</span> {
        <span class="kw">return</span> <span class="prelude-val">None</span>;
    }

    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>, <span class="ident">memchr_runtime_simd</span>))]</span>
    {
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
        {
            <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">memchr_runtime_avx</span>) {
                <span class="kw">if</span> <span class="macro">is_x86_feature_detected!</span>(<span class="string">&quot;avx2&quot;</span>) {
                    <span class="comment">// SAFETY: x86::avx::find only requires the avx2 feature,</span>
                    <span class="comment">// which we&#39;ve just checked above.</span>
                    <span class="kw">return</span> <span class="kw">unsafe</span> { <span class="prelude-val">Some</span>(<span class="ident">PrefilterFn::new</span>(<span class="ident">x86::avx::find</span>)) };
                }
            }
        }
        <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">memchr_runtime_sse2</span>) {
            <span class="comment">// SAFETY: x86::sse::find only requires the sse2 feature, which is</span>
            <span class="comment">// guaranteed to be available on x86_64.</span>
            <span class="kw">return</span> <span class="kw">unsafe</span> { <span class="prelude-val">Some</span>(<span class="ident">PrefilterFn::new</span>(<span class="ident">x86::sse::find</span>)) };
        }
    }
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">not</span>(<span class="ident">miri</span>), <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>, <span class="ident">memchr_runtime_simd</span>))]</span>
    {
        <span class="comment">// SAFETY: `wasm::find` is actually a safe function</span>
        <span class="comment">//</span>
        <span class="comment">// Also note that the `if true` is here to prevent, on wasm with simd,</span>
        <span class="comment">// rustc warning about the code below being dead code.</span>
        <span class="kw">if</span> <span class="bool-val">true</span> {
            <span class="kw">return</span> <span class="kw">unsafe</span> { <span class="prelude-val">Some</span>(<span class="ident">PrefilterFn::new</span>(<span class="ident">wasm::find</span>)) };
        }
    }
    <span class="comment">// Check that our rarest byte has a reasonably low rank. The main issue</span>
    <span class="comment">// here is that the fallback prefilter can perform pretty poorly if it&#39;s</span>
    <span class="comment">// given common bytes. So we try to avoid the worst cases here.</span>
    <span class="kw">let</span> (<span class="ident">rare1_rank</span>, <span class="kw">_</span>) <span class="op">=</span> <span class="ident">rare</span>.<span class="ident">as_ranks</span>(<span class="ident">needle</span>);
    <span class="kw">if</span> <span class="ident">rare1_rank</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">MAX_FALLBACK_RANK</span> {
        <span class="comment">// SAFETY: fallback::find is safe to call in all environments.</span>
        <span class="kw">return</span> <span class="kw">unsafe</span> { <span class="prelude-val">Some</span>(<span class="ident">PrefilterFn::new</span>(<span class="ident">fallback::find</span>)) };
    }
    <span class="prelude-val">None</span>
}

<span class="doccomment">/// Return the minimum length of the haystack in which a prefilter should be</span>
<span class="doccomment">/// used. If the haystack is below this length, then it&#39;s probably not worth</span>
<span class="doccomment">/// the overhead of running the prefilter.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// We used to look at the length of a haystack here. That is, if it was too</span>
<span class="doccomment">/// small, then don&#39;t bother with the prefilter. But two things changed:</span>
<span class="doccomment">/// the prefilter falls back to memchr for small haystacks, and, at the</span>
<span class="doccomment">/// meta-searcher level, Rabin-Karp is employed for tiny haystacks anyway.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// We keep it around for now in case we want to bring it back.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">minimum_len</span>(<span class="ident">_haystack</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">needle</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="ident">usize</span> {
    <span class="comment">// If the haystack length isn&#39;t greater than needle.len() * FACTOR, then</span>
    <span class="comment">// no prefilter will be used. The presumption here is that since there</span>
    <span class="comment">// are so few bytes to check, it&#39;s not worth running the prefilter since</span>
    <span class="comment">// there will need to be a validation step anyway. Thus, the prefilter is</span>
    <span class="comment">// largely redundant work.</span>
    <span class="comment">//</span>
    <span class="comment">// Increase the factor noticeably hurts the</span>
    <span class="comment">// memmem/krate/prebuilt/teeny-*/never-john-watson benchmarks.</span>
    <span class="kw">const</span> <span class="ident">PREFILTER_LENGTH_FACTOR</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">2</span>;
    <span class="kw">const</span> <span class="ident">VECTOR_MIN_LENGTH</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">16</span>;
    <span class="kw">let</span> <span class="ident">min</span> <span class="op">=</span> <span class="ident">core::cmp::max</span>(
        <span class="ident">VECTOR_MIN_LENGTH</span>,
        <span class="ident">PREFILTER_LENGTH_FACTOR</span> <span class="op">*</span> <span class="ident">needle</span>.<span class="ident">len</span>(),
    );
    <span class="comment">// For haystacks with length==min, we still want to avoid the prefilter,</span>
    <span class="comment">// so add 1.</span>
    <span class="ident">min</span> <span class="op">+</span> <span class="number">1</span>
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">test</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>, <span class="ident">not</span>(<span class="ident">miri</span>)))]</span>
<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="ident">std::convert</span>::{<span class="ident">TryFrom</span>, <span class="ident">TryInto</span>};

    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::memmem</span>::{
        <span class="ident">prefilter::PrefilterFnTy</span>, <span class="ident">rabinkarp</span>, <span class="ident">rarebytes::RareNeedleBytes</span>,
    };

    <span class="comment">// Below is a small jig that generates prefilter tests. The main purpose</span>
    <span class="comment">// of this jig is to generate tests of varying needle/haystack lengths</span>
    <span class="comment">// in order to try and exercise all code paths in our prefilters. And in</span>
    <span class="comment">// particular, this is especially important for vectorized prefilters where</span>
    <span class="comment">// certain code paths might only be exercised at certain lengths.</span>

    <span class="doccomment">/// A test that represents the input and expected output to a prefilter</span>
    <span class="doccomment">/// function. The test should be able to run with any prefilter function</span>
    <span class="doccomment">/// and get the expected output.</span>
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">PrefilterTest</span> {
        <span class="comment">// These fields represent the inputs and expected output of a forwards</span>
        <span class="comment">// prefilter function.</span>
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">ninfo</span>: <span class="ident">NeedleInfo</span>,
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">haystack</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">needle</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>,
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">output</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
    }

    <span class="kw">impl</span> <span class="ident">PrefilterTest</span> {
        <span class="doccomment">/// Run all generated forward prefilter tests on the given prefn.</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// # Safety</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// Callers must ensure that the given prefilter function pointer is</span>
        <span class="doccomment">/// safe to call for all inputs in the current environment.</span>
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">run_all_tests</span>(<span class="ident">prefn</span>: <span class="ident">PrefilterFnTy</span>) {
            <span class="ident">PrefilterTest::run_all_tests_filter</span>(<span class="ident">prefn</span>, <span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="bool-val">true</span>)
        }

        <span class="doccomment">/// Run all generated forward prefilter tests that pass the given</span>
        <span class="doccomment">/// predicate on the given prefn.</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// # Safety</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// Callers must ensure that the given prefilter function pointer is</span>
        <span class="doccomment">/// safe to call for all inputs in the current environment.</span>
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">run_all_tests_filter</span>(
            <span class="ident">prefn</span>: <span class="ident">PrefilterFnTy</span>,
            <span class="kw-2">mut</span> <span class="ident">predicate</span>: <span class="kw">impl</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident">PrefilterTest</span>) -&gt; <span class="ident">bool</span>,
        ) {
            <span class="kw">for</span> <span class="ident">seed</span> <span class="kw">in</span> <span class="ident">PREFILTER_TEST_SEEDS</span> {
                <span class="kw">for</span> <span class="ident">test</span> <span class="kw">in</span> <span class="ident">seed</span>.<span class="ident">generate</span>() {
                    <span class="kw">if</span> <span class="ident">predicate</span>(<span class="kw-2">&amp;</span><span class="ident">test</span>) {
                        <span class="ident">test</span>.<span class="ident">run</span>(<span class="ident">prefn</span>);
                    }
                }
            }
        }

        <span class="doccomment">/// Create a new prefilter test from a seed and some chose offsets to</span>
        <span class="doccomment">/// rare bytes in the seed&#39;s needle.</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// If a valid test could not be constructed, then None is returned.</span>
        <span class="doccomment">/// (Currently, we take the approach of massaging tests to be valid</span>
        <span class="doccomment">/// instead of rejecting them outright.)</span>
        <span class="kw">fn</span> <span class="ident">new</span>(
            <span class="ident">seed</span>: <span class="ident">PrefilterTestSeed</span>,
            <span class="ident">rare1i</span>: <span class="ident">usize</span>,
            <span class="ident">rare2i</span>: <span class="ident">usize</span>,
            <span class="ident">haystack_len</span>: <span class="ident">usize</span>,
            <span class="ident">needle_len</span>: <span class="ident">usize</span>,
            <span class="ident">output</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>,
        ) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">PrefilterTest</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rare1i</span>: <span class="ident">u8</span> <span class="op">=</span> <span class="ident">rare1i</span>.<span class="ident">try_into</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rare2i</span>: <span class="ident">u8</span> <span class="op">=</span> <span class="ident">rare2i</span>.<span class="ident">try_into</span>().<span class="ident">unwrap</span>();
            <span class="comment">// The &#39;#&#39; byte is never used in a haystack (unless we&#39;re expecting</span>
            <span class="comment">// a match), while the &#39;@&#39; byte is never used in a needle.</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">haystack</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">b&#39;@&#39;</span>; <span class="ident">haystack_len</span>];
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">needle</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="string">b&#39;#&#39;</span>; <span class="ident">needle_len</span>];
            <span class="ident">needle</span>[<span class="number">0</span>] <span class="op">=</span> <span class="ident">seed</span>.<span class="ident">first</span>;
            <span class="ident">needle</span>[<span class="ident">rare1i</span> <span class="kw">as</span> <span class="ident">usize</span>] <span class="op">=</span> <span class="ident">seed</span>.<span class="ident">rare1</span>;
            <span class="ident">needle</span>[<span class="ident">rare2i</span> <span class="kw">as</span> <span class="ident">usize</span>] <span class="op">=</span> <span class="ident">seed</span>.<span class="ident">rare2</span>;
            <span class="comment">// If we&#39;re expecting a match, then make sure the needle occurs</span>
            <span class="comment">// in the haystack at the expected position.</span>
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>) <span class="op">=</span> <span class="ident">output</span> {
                <span class="ident">haystack</span>[<span class="ident">i</span>..<span class="ident">i</span> <span class="op">+</span> <span class="ident">needle</span>.<span class="ident">len</span>()].<span class="ident">copy_from_slice</span>(<span class="kw-2">&amp;</span><span class="ident">needle</span>);
            }
            <span class="comment">// If the operations above lead to rare offsets pointing to the</span>
            <span class="comment">// non-first occurrence of a byte, then adjust it. This might lead</span>
            <span class="comment">// to redundant tests, but it&#39;s simpler than trying to change the</span>
            <span class="comment">// generation process I think.</span>
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>) <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::memchr</span>(<span class="ident">seed</span>.<span class="ident">rare1</span>, <span class="kw-2">&amp;</span><span class="ident">needle</span>) {
                <span class="ident">rare1i</span> <span class="op">=</span> <span class="ident">u8::try_from</span>(<span class="ident">i</span>).<span class="ident">unwrap</span>();
            }
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>) <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::memchr</span>(<span class="ident">seed</span>.<span class="ident">rare2</span>, <span class="kw-2">&amp;</span><span class="ident">needle</span>) {
                <span class="ident">rare2i</span> <span class="op">=</span> <span class="ident">u8::try_from</span>(<span class="ident">i</span>).<span class="ident">unwrap</span>();
            }
            <span class="kw">let</span> <span class="ident">ninfo</span> <span class="op">=</span> <span class="ident">NeedleInfo</span> {
                <span class="ident">rarebytes</span>: <span class="ident">RareNeedleBytes::new</span>(<span class="ident">rare1i</span>, <span class="ident">rare2i</span>),
                <span class="ident">nhash</span>: <span class="ident">rabinkarp::NeedleHash::forward</span>(<span class="kw-2">&amp;</span><span class="ident">needle</span>),
            };
            <span class="prelude-val">Some</span>(<span class="ident">PrefilterTest</span> { <span class="ident">ninfo</span>, <span class="ident">haystack</span>, <span class="ident">needle</span>, <span class="ident">output</span> })
        }

        <span class="doccomment">/// Run this specific test on the given prefilter function. If the</span>
        <span class="doccomment">/// outputs do no match, then this routine panics with a failure</span>
        <span class="doccomment">/// message.</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// # Safety</span>
        <span class="doccomment">///</span>
        <span class="doccomment">/// Callers must ensure that the given prefilter function pointer is</span>
        <span class="doccomment">/// safe to call for all inputs in the current environment.</span>
        <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">run</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">prefn</span>: <span class="ident">PrefilterFnTy</span>) {
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">prestate</span> <span class="op">=</span> <span class="ident">PrefilterState::new</span>();
            <span class="macro">assert_eq!</span>(
                <span class="self">self</span>.<span class="ident">output</span>,
                <span class="ident">prefn</span>(
                    <span class="kw-2">&amp;mut</span> <span class="ident">prestate</span>,
                    <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">ninfo</span>,
                    <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">haystack</span>,
                    <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">needle</span>
                ),
                <span class="string">&quot;ninfo: {:?}, haystack(len={}): {:?}, needle(len={}): {:?}&quot;</span>,
                <span class="self">self</span>.<span class="ident">ninfo</span>,
                <span class="self">self</span>.<span class="ident">haystack</span>.<span class="ident">len</span>(),
                <span class="ident">std::str::from_utf8</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">haystack</span>).<span class="ident">unwrap</span>(),
                <span class="self">self</span>.<span class="ident">needle</span>.<span class="ident">len</span>(),
                <span class="ident">std::str::from_utf8</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">needle</span>).<span class="ident">unwrap</span>(),
            );
        }
    }

    <span class="doccomment">/// A set of prefilter test seeds. Each seed serves as the base for the</span>
    <span class="doccomment">/// generation of many other tests. In essence, the seed captures the</span>
    <span class="doccomment">/// &quot;rare&quot; and first bytes among our needle. The tests generated from each</span>
    <span class="doccomment">/// seed essentially vary the length of the needle and haystack, while</span>
    <span class="doccomment">/// using the rare/first byte configuration from the seed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The purpose of this is to test many different needle/haystack lengths.</span>
    <span class="doccomment">/// In particular, some of the vector optimizations might only have bugs</span>
    <span class="doccomment">/// in haystacks of a certain size.</span>
    <span class="kw">const</span> <span class="ident">PREFILTER_TEST_SEEDS</span>: <span class="kw-2">&amp;</span>[<span class="ident">PrefilterTestSeed</span>] <span class="op">=</span> <span class="kw-2">&amp;</span>[
        <span class="ident">PrefilterTestSeed</span> { <span class="ident">first</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare1</span>: <span class="string">b&#39;y&#39;</span>, <span class="ident">rare2</span>: <span class="string">b&#39;z&#39;</span> },
        <span class="ident">PrefilterTestSeed</span> { <span class="ident">first</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare1</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare2</span>: <span class="string">b&#39;z&#39;</span> },
        <span class="ident">PrefilterTestSeed</span> { <span class="ident">first</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare1</span>: <span class="string">b&#39;y&#39;</span>, <span class="ident">rare2</span>: <span class="string">b&#39;x&#39;</span> },
        <span class="ident">PrefilterTestSeed</span> { <span class="ident">first</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare1</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare2</span>: <span class="string">b&#39;x&#39;</span> },
        <span class="ident">PrefilterTestSeed</span> { <span class="ident">first</span>: <span class="string">b&#39;x&#39;</span>, <span class="ident">rare1</span>: <span class="string">b&#39;y&#39;</span>, <span class="ident">rare2</span>: <span class="string">b&#39;y&#39;</span> },
    ];

    <span class="doccomment">/// Data that describes a single prefilter test seed.</span>
    <span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
    <span class="kw">struct</span> <span class="ident">PrefilterTestSeed</span> {
        <span class="ident">first</span>: <span class="ident">u8</span>,
        <span class="ident">rare1</span>: <span class="ident">u8</span>,
        <span class="ident">rare2</span>: <span class="ident">u8</span>,
    }

    <span class="kw">impl</span> <span class="ident">PrefilterTestSeed</span> {
        <span class="doccomment">/// Generate a series of prefilter tests from this seed.</span>
        <span class="kw">fn</span> <span class="ident">generate</span>(<span class="self">self</span>) -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">PrefilterTest</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">len_start</span> <span class="op">=</span> <span class="number">2</span>;
            <span class="comment">// The iterator below generates *a lot* of tests. The number of</span>
            <span class="comment">// tests was chosen somewhat empirically to be &quot;bearable&quot; when</span>
            <span class="comment">// running the test suite.</span>
            <span class="comment">//</span>
            <span class="comment">// We use an iterator here because the collective haystacks of all</span>
            <span class="comment">// these test cases add up to enough memory to OOM a conservative</span>
            <span class="comment">// sandbox or a small laptop.</span>
            (<span class="ident">len_start</span>..<span class="op">=</span><span class="number">40</span>).<span class="ident">flat_map</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">needle_len</span><span class="op">|</span> {
                <span class="kw">let</span> <span class="ident">rare_start</span> <span class="op">=</span> <span class="ident">len_start</span> <span class="op">-</span> <span class="number">1</span>;
                (<span class="ident">rare_start</span>..<span class="ident">needle_len</span>).<span class="ident">flat_map</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">rare1i</span><span class="op">|</span> {
                    (<span class="ident">rare1i</span>..<span class="ident">needle_len</span>).<span class="ident">flat_map</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">rare2i</span><span class="op">|</span> {
                        (<span class="ident">needle_len</span>..<span class="op">=</span><span class="number">66</span>).<span class="ident">flat_map</span>(<span class="kw">move</span> <span class="op">|</span><span class="ident">haystack_len</span><span class="op">|</span> {
                            <span class="ident">PrefilterTest::new</span>(
                                <span class="self">self</span>,
                                <span class="ident">rare1i</span>,
                                <span class="ident">rare2i</span>,
                                <span class="ident">haystack_len</span>,
                                <span class="ident">needle_len</span>,
                                <span class="prelude-val">None</span>,
                            )
                            .<span class="ident">into_iter</span>()
                            .<span class="ident">chain</span>(
                                (<span class="number">0</span>..<span class="op">=</span>(<span class="ident">haystack_len</span> <span class="op">-</span> <span class="ident">needle_len</span>)).<span class="ident">flat_map</span>(
                                    <span class="kw">move</span> <span class="op">|</span><span class="ident">output</span><span class="op">|</span> {
                                        <span class="ident">PrefilterTest::new</span>(
                                            <span class="self">self</span>,
                                            <span class="ident">rare1i</span>,
                                            <span class="ident">rare2i</span>,
                                            <span class="ident">haystack_len</span>,
                                            <span class="ident">needle_len</span>,
                                            <span class="prelude-val">Some</span>(<span class="ident">output</span>),
                                        )
                                    },
                                ),
                            )
                        })
                    })
                })
            })
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="memchr" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>